//+------------------------------------------------------------------+
//|                                            My_Channel_Colors.mq4 |
//|                                                       SEFC       |
//|                                 Modified by MickyMouse :D        |
//|          http://www.myfxbook.com/members/MiChAeL_FX/swing/114252 |
//+------------------------------------------------------------------+
#property copyright "SEFC"
#property link      ""


#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1 MidnightBlue
#property indicator_color2 MidnightBlue
#property indicator_color3 Red
#property indicator_color4 Red
#property indicator_color5 RoyalBlue
#property indicator_color6 RoyalBlue
#property indicator_color7 Orange
#property indicator_color8 Orange
#property indicator_width1 3
#property indicator_width2 3
#property indicator_width3 3
#property indicator_width4 3
#property indicator_width5 3
#property indicator_width6 3
#property indicator_width7 3
#property indicator_width8 3



extern int LngPeriod = 50;
extern int MedPeriod = 20;
extern int ShtPeriod = 8;
extern int Extremes = 1;
extern int Margins = 0;
extern int Advance = 0;

double g_ibuf_150[];
double g_ibuf_151[];
double g_ibuf_152[];
double g_ibuf_153[];
double g_ibuf_154[];
double g_ibuf_155[];
double g_ibuf_156[];
double g_ibuf_157[];

int init() {
   SetIndexStyle(0, DRAW_HISTOGRAM, STYLE_SOLID, 3);SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,4);
   SetIndexStyle(1, DRAW_HISTOGRAM, STYLE_SOLID, 3);
   SetIndexStyle(2, DRAW_HISTOGRAM, STYLE_SOLID, 3);
   SetIndexStyle(3, DRAW_HISTOGRAM, STYLE_SOLID, 3);SetIndexStyle(3,DRAW_LINE,STYLE_SOLID,4);
   SetIndexStyle(4, DRAW_HISTOGRAM, STYLE_SOLID, 3);SetIndexStyle(4,DRAW_LINE,STYLE_SOLID,4);
   SetIndexStyle(5, DRAW_HISTOGRAM, STYLE_SOLID, 3);
   SetIndexStyle(6, DRAW_HISTOGRAM, STYLE_SOLID, 3);
   SetIndexStyle(7, DRAW_HISTOGRAM, STYLE_SOLID, 3);SetIndexStyle(7,DRAW_LINE,STYLE_SOLID,4);
   SetIndexBuffer(0, g_ibuf_150);
   SetIndexBuffer(1, g_ibuf_151);
   SetIndexBuffer(2, g_ibuf_152);
   SetIndexBuffer(3, g_ibuf_153);
   SetIndexBuffer(4, g_ibuf_154);
   SetIndexBuffer(5, g_ibuf_155);
   SetIndexBuffer(6, g_ibuf_156);
   SetIndexBuffer(7, g_ibuf_157);

   

   return (0);
}

int deinit() {
   return (0);
}

int start() {
  
   int li_0 = IndicatorCounted();
   if (li_0 < 0) return (-1);
   if (li_0 > 0) li_0--;
   int li_4 = Bars - li_0;
   double ld_8 = 0;
   double ld_16 = 0;
   double ld_24 = 0;
   double ld_32 = 0;
   double ld_40 = 0;
   double ld_48 = 0;
   double ld_56 = 0;
   double ld_64 = 0;
   double ld_72 = 0;
   double ld_80 = 0;
   double ld_88 = 0;
   double ld_96 = 0;
   for (int li_104 = li_4; li_104 >= 0; li_104--) {
      if (Extremes == 1) {
         ld_32 = High[iHighest(NULL, 0, MODE_HIGH, LngPeriod, li_104)];
         ld_24 = Low[iLowest(NULL, 0, MODE_LOW, LngPeriod, li_104)];
         ld_64 = High[iHighest(NULL, 0, MODE_HIGH, MedPeriod, li_104)];
         ld_56 = Low[iLowest(NULL, 0, MODE_LOW, MedPeriod, li_104)];
         ld_96 = High[iHighest(NULL, 0, MODE_HIGH, ShtPeriod, li_104)];
         ld_88 = Low[iLowest(NULL, 0, MODE_LOW, ShtPeriod, li_104)];
      } else {
         if (Extremes == 3) {
            ld_32 = (Open[iHighest(NULL, 0, MODE_OPEN, LngPeriod, li_104)] + High[iHighest(NULL, 0, MODE_HIGH, LngPeriod, li_104)]) / 2.0;
            ld_24 = (Open[iLowest(NULL, 0, MODE_OPEN, LngPeriod, li_104)] + Low[iLowest(NULL, 0, MODE_LOW, LngPeriod, li_104)]) / 2.0;
            ld_64 = (Open[iHighest(NULL, 0, MODE_OPEN, MedPeriod, li_104)] + High[iHighest(NULL, 0, MODE_HIGH, MedPeriod, li_104)]) / 2.0;
            ld_56 = (Open[iLowest(NULL, 0, MODE_OPEN, MedPeriod, li_104)] + Low[iLowest(NULL, 0, MODE_LOW, MedPeriod, li_104)]) / 2.0;
            ld_96 = (Open[iHighest(NULL, 0, MODE_OPEN, ShtPeriod, li_104)] + High[iHighest(NULL, 0, MODE_HIGH, ShtPeriod, li_104)]) / 2.0;
            ld_88 = (Open[iLowest(NULL, 0, MODE_OPEN, ShtPeriod, li_104)] + Low[iLowest(NULL, 0, MODE_LOW, ShtPeriod, li_104)]) / 2.0;
         } else {
            ld_32 = Open[iHighest(NULL, 0, MODE_OPEN, LngPeriod, li_104)];
            ld_24 = Open[iLowest(NULL, 0, MODE_OPEN, LngPeriod, li_104)];
            ld_64 = Open[iHighest(NULL, 0, MODE_OPEN, MedPeriod, li_104)];
            ld_56 = Open[iLowest(NULL, 0, MODE_OPEN, MedPeriod, li_104)];
            ld_96 = Open[iHighest(NULL, 0, MODE_OPEN, ShtPeriod, li_104)];
            ld_88 = Open[iLowest(NULL, 0, MODE_OPEN, ShtPeriod, li_104)];
         }
      }
      ld_16 = ld_32 - (ld_32 - ld_24) * Margins / 100.0;
      ld_8 = ld_24 + (ld_32 - ld_24) * Margins / 100.0;
      ld_48 = ld_64 - (ld_64 - ld_56) * Margins / 100.0;
      ld_40 = ld_56 + (ld_64 - ld_56) * Margins / 100.0;
      ld_80 = ld_96 - (ld_96 - ld_88) * Margins / 100.0;
      ld_72 = ld_88 + (ld_96 - ld_88) * Margins / 100.0;
      
      g_ibuf_150[li_104 - Advance] = ld_8;
      g_ibuf_151[li_104 - Advance] = ld_40;
      g_ibuf_152[li_104 - Advance] = ld_16;
      g_ibuf_153[li_104 - Advance] = ld_48;
      g_ibuf_154[li_104 - Advance] = ld_40;
      g_ibuf_155[li_104 - Advance] = ld_72;
      g_ibuf_156[li_104 - Advance] = ld_48;
      g_ibuf_157[li_104 - Advance] = ld_80;
   
 }  
   return (0);
}